searchData={"items":[{"type":"module","title":"CertMagex","doc":"Automatic SSL certs from Let's Encrypt for your Phoenix applications.","ref":"CertMagex.html"},{"type":"module","title":"Installation - CertMagex","doc":"For Cowboy add to your prod.exs:\n\n```elixir\nconfig  ,  ,\n  # ATTENTION: Ensure you comment http: out and port 80 is free!\n  https: [port: 443, sni_fun: &CertMagex.sni_fun/1],\n  ...\n```\n\nFor Bandit add to your prod.exs:\n\n```elixir\nconfig  ,  ,\n  # ATTENTION: Ensure you comment http: out and port 80 is free!\n  https: [port: 443, thousand_island_options: [transport_options: [sni_fun: &CertMagex.sni_fun/1]]],\n  ...\n```","ref":"CertMagex.html#module-installation"},{"type":"function","title":"CertMagex.insert/2","doc":"Insert a certificate into the cache. Automatically detects all domains in the certificate.","ref":"CertMagex.html#insert/2"},{"type":"function","title":"CertMagex.insert/3","doc":"Insert a certificate into the cache for a specific domain.","ref":"CertMagex.html#insert/3"},{"type":"function","title":"CertMagex.sni_fun/1","doc":"The SNI function to be used in your Phoenix or Cowboy configuration. E.g. for\nCowboy add this to your prod.exs:\n\n```elixir\nconfig  ,  ,\n  # ATTENTION: Ensure you comment http: out and port 80 is free!\n  https: [port: 443, sni_fun: &CertMagex.sni_fun/1],\n  ...\n```","ref":"CertMagex.html#sni_fun/1"},{"type":"module","title":"CertMagex.Acmev2","doc":"Implementation of the ACMEv2 protocol for Zerossl (on Elliptic Curves cryptography)","ref":"CertMagex.Acmev2.html"},{"type":"function","title":"CertMagex.Acmev2.cert_print/1","doc":"Print a certificate content","ref":"CertMagex.Acmev2.html#cert_print/1"},{"type":"macro","title":"CertMagex.Acmev2.csr/1","doc":"","ref":"CertMagex.Acmev2.html#csr/1"},{"type":"macro","title":"CertMagex.Acmev2.csr/2","doc":"","ref":"CertMagex.Acmev2.html#csr/2"},{"type":"macro","title":"CertMagex.Acmev2.ecdsa_key/1","doc":"","ref":"CertMagex.Acmev2.html#ecdsa_key/1"},{"type":"macro","title":"CertMagex.Acmev2.ecdsa_key/2","doc":"","ref":"CertMagex.Acmev2.html#ecdsa_key/2"},{"type":"macro","title":"CertMagex.Acmev2.ecdsa_signature/1","doc":"","ref":"CertMagex.Acmev2.html#ecdsa_signature/1"},{"type":"macro","title":"CertMagex.Acmev2.ecdsa_signature/2","doc":"","ref":"CertMagex.Acmev2.html#ecdsa_signature/2"},{"type":"function","title":"CertMagex.Acmev2.gen_cert/1","doc":"Generates a certificate through ACMEv2 protocol for the specified domain.\n\nThe following ACMEv2 providers are supported\n\n- `:zerossl` [*]\n- `:letsencrypt`\n- `:letsencrypt_test`\n\nZerossl requires EAB (External Account Binding) prior to issue a certificate:\nyou will have to register with a proper email to it. Once you've\ncreated an account, you can either provide the email or the account key (I've\nseen it called \"access key\" or \"API key\" around) in the configuration.\nThe code tries to lookup for the email, and when not found, defaults\nto the `:account_key`. You can find your account key (called API key in zerossl)\nhere:\n\n    https://app.zerossl.com/developer\n\n\nTo perform the authentication the EAB credentails must be retrieved.\nThese are saved on a file `eab_credentials.json` to be reused\nfor the following interactions with Zerossl service APIs\n\nThe authentication method relies on the HTTP (not DNS). For it to work\n`gen_cert` opens a listening socket on port 80 where it serves the\nwell-known file retrieved from the APIs exchange. When the procedure\ncompletes the socket is closed.\n\nBy demonstrating the ownership of the site the user gets trusted by\nthe Zerossl service and the certificate is emitted.\n\nThe function returns a key and its related certificate. Those\ncan be used to run a trusted HTTPs server.\n\nThe key and certificate values are in binary encoded format and can be\ndirectly written on a file","ref":"CertMagex.Acmev2.html#gen_cert/1"},{"type":"function","title":"CertMagex.Acmev2.jws_dec/1","doc":"Print a JWS content","ref":"CertMagex.Acmev2.html#jws_dec/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}